﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace puzzle_zero_rows_columns2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Demonstrate the algorithm.
        private void btnGo_Click(object sender, EventArgs e)
        {
            // Load the array.
            int num_rows = txtInput.Lines.Length;
            int num_cols = txtInput.Lines[0].Replace(" ", "").Length;
            int[,] values = new int[num_rows, num_cols];
            for (int row = 0; row < num_rows; row++)
            {
                string line = txtInput.Lines[row].Replace(" ", "");
                for (int col = 0; col < num_cols; col++)
                {
                    values[row, col] = int.Parse(line.Substring(col, 1));
                }
            }

            // Zero the appropriate rows and columns.
            ZeroRowsAndColumns(values);

            // Display the result.
            string result = "";
            for (int row = 0; row < num_rows; row++)
            {
                for (int col = 0; col < num_cols; col++)
                {
                    result += values[row, col].ToString() + " ";
                }
                // Remove the final " " and add a new line.
                result = result.Substring(0, result.Length - 1) + "\r\n";
            }

            // Remove the final \r\n.
            result = result.Substring(0, result.Length - 2);
            txtResult.Text = result;
        }

        // Insert the algorithm here.
        private void ZeroRowsAndColumns(int[,] values)
        {
            // Make an array to hold values
            // indicating where there are zeros.
            bool[,] is_zero = new bool[
                values.GetUpperBound(0) + 1,
                values.GetUpperBound(1) + 1];

            // Set is_zero for values that are 0.
            for (int row = 0; row <= values.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= values.GetUpperBound(1); col++)
                {
                    is_zero[row, col] = (values[row, col] == 0);
                }
            }

            // Zero out the appropriate rows and columns.
            for (int row = 0; row <= values.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= values.GetUpperBound(1); col++)
                {
                    // See if this entry in the original array is zero.
                    if (is_zero[row, col])
                    {
                        // Zero out the column.
                        // If this is the first row or this column has
                        // not already been zeroed, zero it out.
                        if ((row == 0) || (!is_zero[0, col]))
                        {
                            for (int r = 0; r <= values.GetUpperBound(0); r++)
                            {
                                values[r, col] = 0;
                            }
                        }
                        else
                        {
                            Console.WriteLine("Skipping column " + col.ToString() + ".");
                        }

                        // Zero out the row.
                        // If this is the first column or this row has
                        // not already been zeroed, zero it out.
                        if ((col == 0) || (!is_zero[row, 0]))
                        {
                            for (int c = 0; c <= values.GetUpperBound(1); c++)
                            {
                                values[row, c] = 0;
                            }
                        }
                        else
                        {
                            Console.WriteLine("Skipping row " + row.ToString() + ".");
                        }

                        // Set is_zero to mark the row and column as zeroed.
                        is_zero[row, 0] = true;
                        is_zero[0, col] = true;
                    }
                }
            }
            Console.WriteLine("Done");
        }
    }
}
